# shoulder-dev-specs

shoulder 的开发规范。

依赖的 docker：
```
FROM maven:3-jdk-11
# self center repository
COPY settings.xml /usr/share/maven/conf
COPY settings.xml /usr/share/maven/ref/settings-docker.xml
COPY settings.xml /root/.m2/settings-docker.xml
#COPY repository /root/.m2/repository
```

docker build -t cnlym/maven:3-jdk-11-alpine-aliyun .


```bash
L:\baseEnvironment\Toolbox\apps\IDEA-U\ch-0\232.8660.185\plugins\maven\lib\maven3\bin\mvn generate-resources
```

# 踩坑记录

## 坑：【2021 java16就开始有了，现在还没解决】
翻asciidoctor github issue 发现；去除 jruby 主动依赖解决（本身是可选的）

WARN FilenoUtil : Native subprocess control requires open access to the JDK IO subsystem
Pass '--add-opens java.base/sun.nio.ch=ALL-UNNAMED --add-opens java.base/java.io=ALL-UNNAMED' to enable.

JRuby 的代码导致：
asciidoctor-issue https://github.com/asciidoctor/asciidoctor-maven-plugin/issues/553
https://github.com/asciidoctor/asciidoctorj/issues/1035

jruby-issue
https://github.com/jruby/jruby/issues/6721

提到是JDK的安全更新但未提供替代方法原因

## 坑2： asciidoctor adoc 源文件默认路径调整过
翻asciidoctor github README解决

最早：默认指向 ${basedir}/src/main/asciidoc

后来：默认指向 ${basedir}/src/site/asciidoc

## 坑3： java.lang.NoSuchFieldError: STRIO_READABLE
去除 jruby 主动依赖解决（本身是可选的）
